import { DiffGradient } from '@double-agent/analyze/lib/scorers';
import { PositiveMatcher } from '@double-agent/analyze/lib/matchers';
import Plugin from '@double-agent/analyze/lib/Plugin';
import IProfile from '@double-agent/collect-http-websockets/interfaces/IProfile';
import CheckGenerator from './lib/CheckGenerator';

export default class HttpWebsocketHeaders extends Plugin {
  initialize(profiles: IProfile[]) {
    const checks: any[] = [];
    for (const profile of profiles) {
      const checkGenerator = new CheckGenerator(profile);
      checks.push(...checkGenerator.checks);
    }

    this.initializeProbes({
      layerKey: 'WSH',
      layerName: 'Websocket Headers',
      // description: 'Compares header order, capitalization and default values to normal (recorded) user agent values',
      checks,
      matcher: PositiveMatcher,
      scorer: DiffGradient,
    });
  }

  override runIndividual(profile: any) {
    const checkGenerator = new CheckGenerator(profile);
    return this.runProbes('WSH', profile.userAgentId, checkGenerator.checks);
  }
}
